{
#include <cstring>

struct roundtrip {
Int_t testid;
Int_t microseconds;
Int_t sourceid;
Int_t destid;
Float_t delay;
Float_t jitter;
Float_t loss;
char datetime[20];
};

roundtrip vround;

// create root file
TFile *f1 = new TFile("koga.root", "RECREATE");

// create tree
TTree *T = new TTree("T", "Dados do PipesBr Unifacs RoundTrip");

//create branch
//solution 1; move string at the end of the structure
T->Branch("RoundTrip", &vround,
"testid/I:microseconds:sourceid:destid:delay/F:jitter:loss:datetime/C");
//solution 2; create separate branches per type
T->Branch("Tripi", &vround.testid,"testid/I:microseconds:sourceid:destid");
T->Branch("Tripf", &vround.delay,"delay/F:jitter:loss");
T->Branch("Tripc", &vround.datetime[0],"datetime/C");
//solution 3; create one branch per type
T->Branch("Tripi", &vround.testid,"testid/I:microseconds:sourceid:destid");
//solution 4; use one class instead of a struct. In this case each member
// will automatically go to a separate branch

//insert in the tree

for (int i=0; i < 10; i++) {
   vround.testid=i;
   vround.microseconds=1000*i;
   vround.sourceid=100+i;
   vround.destid=1000+i;
   sprintf(vround.datetime,"datetime=%d",i);
   vround.delay=1+0.1*i;
   vround.jitter=100+i;
   vround.loss = 1000+i;
   T->Fill();
}
T->Print();
T->Show(5);
T->Write();
}
